/* Game Class Header File
 * Krysta Mirzayans  10/05/06
 */

#ifndef GAME_H
#define GAME_H

#include <iostream>
using namespace std;

//Game type constants:
const int TYPE1 = 1;
const int TYPE2 = 2;
const int TYPE3 = 3;

class Game
{
 public:
  Game(int *opponents);              //Ctor: sets the players
  ~Game();                           //Dtor: deletes players memory
  Game(const Game &);                //Cctor 
  Game &operator= (const Game &);    //Assign op
  int *getPlayers();                 //Public read access to players 
  void play();                       //Plays the Game*****************

  const static int type = TYPE2;     //*******Where do you set this?
  static int getNumPlayers();        //Gets the number of players involved 
                                     //in a game of the given game type  
  void display();                    //Displays the game object

 private:
  int *players;                      //Players involved in this game
  int *result;                       //Result of the game corresponding 
                                     //to each player
  bool valid;                        //Flag: are results in this game valid?
};

#endif
