#include "tmanager.h"

// This function prints the contents of a one dimentional int array in the form "1, 2, 3..."
void printIntArray(int anArray[], int size)
{
	// Check to make sure the array isn't empty
	if(size > 0)
	{
		printf("%i", anArray[0]);
		for(int i = 1; i < size; ++i)
		{
			printf(", %i", anArray[i]);
		}
	}
}



int main(int argc, char *argv[])    
{
	// Check to make sure we have the correct number of arguments if not display a little help message
	// TODO: add a check to see if the argv[1] is "--help" then display the help message
	if(argc != 3)
	{
		printf("Usage:\n\ttmanager [#servers] [#players]\n");
		printf("\nThis will change once the config file stuff is ready.\nProbably to something like:\n\ttmanager [configFile] [log]\n");
		return 0;
	}
	
	// move the int value of the agrv 1 and 2 into ints so we can use them later
	int serverCount = atoi(argv[1]);	// the number of servers that we have
	int playerCount = atoi(argv[2]);	// the number of players that we have
	
	printf("We have %i servers to use and %i players.\n", serverCount, playerCount);
	
	// Make an array containing each player. For example if we have 3 players the array will contain: 1,2,3
	int players[playerCount];
	for(int i = 1; i <= playerCount; ++i)
	{
		players[i-1] = i;
	}
	
	// Print the player list
	printf("Player List: ");
	printIntArray(players, playerCount);
	printf("\n");
	
	// Generate the game pairs and print them.
	printf("\nGame List:\n");
	for(int i = 0; i < playerCount; ++i)
	{
		for(int j = 1; j < playerCount - i; ++j)
		{
			printf("\t%i vs %i\n", players[i], players[j+i]);
		}
	}
	
	printf("\nTournament Manager is Done!\n");
}

