#include "Game.H"
#include "GameStateModule.H"

#include "GobPtrWrapper_G3.H"
//#include "Game1_GlobalState.H"

using namespace std;

const string Worker::miningComponent("pickaxe");
const string Worker::miningAction("mine");
const string Worker::returnResourcesAction("return_resources");

ScalarPoint GobPtrWrapper::getPosition(void) const
{
  return ScalarPoint(*(gob->sod.x), *(gob->sod.y));
}

bool GobPtrWrapper::isMoving(void) const 
{ 
  return (*(gob->sod.speed) > 0) || (*(gob->sod.is_moving) != 0);
}

/**************************************************************************/

void Worker::returnMinerals(const GobPtrWrapper& controlCenter)
{
  PlayerInfo& pi = gsm.get_game().get_cplayer_info();
  Vector<sint4> args(1, pi.get_id(const_cast<GobPtrWrapper&>(controlCenter)));
  gob->set_action(returnResourcesAction, args);

  //cout << static_cast<Object*>(gob) << " Return minerals (" << getMinerals() << ")" << endl;
}

void Worker::startMining(const GobPtrWrapper& mineral)
{
  PlayerInfo& pi = gsm.get_game().get_cplayer_info();
  Vector<sint4> args(1, pi.get_id(const_cast<GobPtrWrapper&>(mineral)));
  gob->component(miningComponent)->set_action(miningAction, args);

  //cout << static_cast<Object*>(gob) << " Start mining" << endl;
}


sint4 Worker::getMinerals(void) const 
{
  return gob->get_int("minerals"); 
}

bool Worker::isMining(void) const 
{
  //cout << gob << "isMining=" << (gob->component(miningComponent)->get_int("active") != 0) << endl;
  return gob->component(miningComponent)->get_int("active") != 0; 
}

