#ifndef CycleCounter_H
#define CycleCounter_H

// $Id: CycleCounter.H,v 1.2 2005/05/11 00:26:18 orts_mburo Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

// x86 cycle counter, useful for profiling
// SYSTEM DEPENDENT!

#include "Global.H"

struct CycleCounter {

public:

  union {
    uint8 c8;
    struct { uint4 l, h; } c4;
  } count_;
  
  void stamp() {
#ifdef __i386__
    __asm__ __volatile__ (".byte 0x0f,0x31" : "=a"(count_.c4.l),"=d"(count_.c4.h));
#else
    count_.c8 = 0;
#endif    
  }

  uint8 count() const { return count_.c8; }
  
  CycleCounter() { stamp(); }
};

#endif
