#ifndef GameConst_H
#define GameConst_H

// $Id: GameConst.H,v 1.5 2006/06/26 03:04:22 orts_furtak Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

class GameConst {

public:

  static const sint4 PLAYER_MAX = 4;
  static const sint4 ELEM_NUM_MAX = 20000; ///< Number of object ids available.
  static const sint4 VIEW_MAX = 11;        ///< Maximum vision distance in tiles.
  static const sint4 VIEW_WIDTH = VIEW_MAX*2+1;
  static const sint4 WIDTH_SQUARED = GameConst::VIEW_WIDTH * GameConst::VIEW_WIDTH;
  static const sint4 ACTION_EXPIRATION = 20;

  static const sint4 TILE_POINTS = 16; ///< Number of file points on a tile edge.
                                       // fixme: should not be constant, but in many places
                                       // don't have direct access to a game
  
  static const sint4 HEIGHT_MULT = 2*2*3; ///< Height value that constitutes one tile unit.
                                          // fixme: should not be a constant either
                                          // depends somewhat on the GUI
                                          // 2*2*3 -> ramps can have slopes 1,1/2,1/3,1/4,1/6...

  // granularity of directions
  static const sint4 DAMAGE_N = 32;  ///< Detected incoming attacks.
  static const sint4 HEADING_N = 32; ///< Heading of current motion.
  static const sint4 ATTACK_N = 16;  ///< Direction currently attacking.

  static sint4 encode_dir(sint4 dx, sint4 dy, sint4 num_headings);
  static real8 angle_from_dir(sint4 dir, sint4 num_headings);
};

#endif
