#ifndef Text_IO_Buffer_H
#define Text_IO_Buffer_H

// $Id: Text_IO_Buffer.H,v 1.7 2006/08/01 18:30:18 orts_mburo Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "IO_Buffer.H"

class Text_IO_Buffer : public IO_Buffer
{
public:
  
  // Text_IO_Buffer() {}

  /**
   * constructor
   * @param so        The socket to read from and write to.
   * @param blocking  Blocking or nonblocking IO.
   * @param rand_delay Random delay of messages iff != 0
  */

  Text_IO_Buffer(TCPsocket so_, bool blocking_, RandSrc *rand_delay=0);

  /**
    * returns current size of i_buf (before removing the message)
    * or -1 if read error occurred, blocks of the buffer was set to block
    */
  virtual sint4 read(std::string &s);

  virtual ~Text_IO_Buffer();
  
protected:

  SDL_sem *read_sem; ///< semaphore for blocking the read call
  bool    blocking;  ///< blocking or non blocking IO
  
  /**
  * reads the message until the first newline character
  * returns the length of the messege read excluding the newline
  */
  sint4 probing_blocking_read(void *buffer);   

public:

  static int write_loop(void *data);
  static int read_loop(void *data);
};

#endif
