#include "BasicObject.H"

BasicObject::BasicObject( Ogre::String &objName, Ogre::SceneManager* gdSceneMgr, GameObj *gameObj, std::map<std::string, std::string> &bpName2MeshNameMap){
  this->gdSceneMgr = gdSceneMgr;
  this->gameObj = gameObj;	

  //determine from gameObj->bp_name() which mesh is loaded.
  if( bpName2MeshNameMap[gameObj->bp_name()].empty() ){ //if they dont match
    objEntity = gdSceneMgr->createEntity(objName, "mech");  
    objEntity->setMaterialName("mech");
  }else{
    std::cout << "Adding object:" << bpName2MeshNameMap[gameObj->bp_name()] << std::endl;
    objEntity = gdSceneMgr->createEntity(objName, bpName2MeshNameMap[gameObj->bp_name()]);

    //animationSet = new OgreGfxAnimationSet(objEntity);  //Create 5 animation sets.
    //animationSet->idleAnimationState->setLoop(true);
    //animationSet->idleAnimationState->setEnabled(true); 
  } 
 
  //create the object before adding it to list.  
  this->objName = objName;	
  
  objNode = gdSceneMgr->getRootSceneNode()->createChildSceneNode();
  objNode->attachObject( objEntity );						//add to SceneNode which adds to Scene/display.
    
  selectedObject = false;  //Object is obviously not selected upon creation.
}

