/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef Server_H
#define Server_H

#include "Global.H"
#include <list>

class ServerClient;

class Server {

public:
  
  typedef list<ServerClient*> CLIENT_CONT;
  CLIENT_CONT clients;

protected:

  sint4 ibl, obl; // buffer lengths for SocketClient
  bool  terminated;
  sint4 socket;

  void accept_connection();

public:  
  
  Server(sint4 ibl_=32768, sint4 obl_=32768)
  {
    ibl = ibl_;
    obl = obl_;
    assert(ibl > 0);
    assert(obl > 0);
    socket = -1;
    terminated = false;
  }

  sint4 init_listen(sint4 port);
  bool handle_connection();
  void loop();
  bool read_wait();
  
  virtual ~Server();
};

#endif
